"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createApp = void 0;
var koa_1 = __importDefault(require("koa"));
var router_1 = __importDefault(require("@koa/router"));
var createApp = function (_a) {
    if (_a === void 0) { _a = {}; }
    var _b = _a.controllers, controllers = _b === void 0 ? [] : _b, _c = _a.middlewares, middlewares = _c === void 0 ? [] : _c, options = __rest(_a, ["controllers", "middlewares"]);
    var app = new koa_1.default(options);
    middlewares.forEach(function (middleware) { return app.use(middleware); });
    controllers.forEach(function (controller) {
        var controllerPath = Reflect.getMetadata('path', controller.constructor);
        var controllerRoutes = Reflect.getMetadata('routes', controller.constructor);
        var controllerMiddlewares = Reflect.getMetadata('middlewares', controller.constructor);
        var router = new router_1.default({
            prefix: controllerPath
        });
        router.use.apply(router, controllerMiddlewares);
        controllerRoutes.forEach(function (_a) {
            var path = _a.path, method = _a.method, handler = _a.handler, middlewares = _a.middlewares;
            console.log(path);
            router[method].apply(router, __spreadArray(__spreadArray([path], middlewares), [handler.bind(controller)]));
        });
        app.use(router.routes());
    });
    return app;
};
exports.createApp = createApp;
