import { Middleware } from 'koa';
export declare type HttpMethod = 'all' | 'get' | 'post' | 'put' | 'patch' | 'delete';
interface DefinedRouteOptions {
    path?: string;
    middlewares?: Middleware[];
}
interface RouteOptions extends DefinedRouteOptions {
    method: HttpMethod;
}
export interface Route {
    path: string;
    method: HttpMethod;
    middlewares: Middleware[];
    handler: Middleware;
}
declare type RouteDecorator = (options: RouteOptions) => MethodDecorator;
declare type DefinedRouteDecorator = (options?: DefinedRouteOptions) => MethodDecorator;
export declare const Route: RouteDecorator;
export declare const All: DefinedRouteDecorator;
export declare const Get: DefinedRouteDecorator;
export declare const Post: DefinedRouteDecorator;
export declare const Put: DefinedRouteDecorator;
export declare const Patch: DefinedRouteDecorator;
export declare const Delete: DefinedRouteDecorator;
export {};
