"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Delete = exports.Patch = exports.Put = exports.Post = exports.Get = exports.All = exports.Route = void 0;
var Route = function (_a) {
    var _b = _a.path, path = _b === void 0 ? '/' : _b, _c = _a.middlewares, middlewares = _c === void 0 ? [] : _c, method = _a.method;
    return function (target, _propertyKey, descriptor) {
        if (!Reflect.hasMetadata('routes', target.constructor)) {
            Reflect.defineMetadata('routes', [], target.constructor);
        }
        var routes = Reflect.getMetadata('routes', target.constructor);
        routes.push({
            path: path,
            method: method,
            middlewares: middlewares,
            handler: descriptor.value
        });
    };
};
exports.Route = Route;
var All = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'all' });
};
exports.All = All;
var Get = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'get' });
};
exports.Get = Get;
var Post = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'post' });
};
exports.Post = Post;
var Put = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'put' });
};
exports.Put = Put;
var Patch = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'patch' });
};
exports.Patch = Patch;
var Delete = function (_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.path, path = _c === void 0 ? '/' : _c, _d = _b.middlewares, middlewares = _d === void 0 ? [] : _d;
    return exports.Route({ path: path, middlewares: middlewares, method: 'delete' });
};
exports.Delete = Delete;
